(function (_, kotlin_kotlin, kotlin_com_zegreatrob_tools_digger_core) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var split = kotlin_kotlin.$_$.e8;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.j2;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.g;
  var toInt = kotlin_kotlin.$_$.l8;
  var Unit_instance = kotlin_kotlin.$_$.v1;
  var charSequenceLength = kotlin_kotlin.$_$.g5;
  var charSequenceGet = kotlin_kotlin.$_$.f5;
  var digitToIntOrNull = kotlin_kotlin.$_$.g7;
  var protoOf = kotlin_kotlin.$_$.d6;
  var classMeta = kotlin_kotlin.$_$.i5;
  var setMetadataFor = kotlin_kotlin.$_$.e6;
  var Enum = kotlin_kotlin.$_$.w8;
  var THROW_CCE = kotlin_kotlin.$_$.d9;
  var isCharSequence = kotlin_kotlin.$_$.t5;
  var trim = kotlin_kotlin.$_$.q8;
  var toString = kotlin_kotlin.$_$.g6;
  var Companion_instance = kotlin_kotlin.$_$.u1;
  var get = kotlin_kotlin.$_$.k7;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.m1;
  var createFailure = kotlin_kotlin.$_$.g9;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.n1;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.p1;
  var substringBefore = kotlin_kotlin.$_$.i8;
  var contains = kotlin_kotlin.$_$.e7;
  var to = kotlin_kotlin.$_$.m9;
  var hashCode = kotlin_kotlin.$_$.q5;
  var equals = kotlin_kotlin.$_$.k5;
  var Defaults_getInstance = kotlin_com_zegreatrob_tools_digger_core.$_$.a;
  var objectMeta = kotlin_kotlin.$_$.c6;
  //endregion
  //region block: pre-declaration
  setMetadataFor(ChangeType, 'ChangeType', classMeta, Enum);
  setMetadataFor(ChangeType$Major, 'Major', classMeta, ChangeType);
  setMetadataFor(ChangeType$Minor, 'Minor', classMeta, ChangeType);
  setMetadataFor(ChangeType$Patch, 'Patch', classMeta, ChangeType);
  setMetadataFor(ChangeType$None, 'None', classMeta, ChangeType);
  setMetadataFor(TaggerCore, 'TaggerCore', classMeta);
  setMetadataFor(Defaults, 'Defaults', objectMeta);
  setMetadataFor(Companion, 'Companion', objectMeta);
  setMetadataFor(VersionRegex, 'VersionRegex', classMeta);
  //endregion
  function asSemverComponents(_this__u8e3s4) {
    // Inline function 'kotlin.collections.map' call
    var this_0 = split(stripPrefix(_this__u8e3s4), ['.']);
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var item = tmp0_iterator.u();
      var tmp$ret$0 = toInt(item);
      destination.o(tmp$ret$0);
    }
    return destination;
  }
  function stripPrefix(_this__u8e3s4) {
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.text.indexOfFirst' call
      var inductionVariable = 0;
      var last = charSequenceLength(_this__u8e3s4) - 1 | 0;
      if (inductionVariable <= last)
        do {
          var index = inductionVariable;
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'com.zegreatrob.tools.tagger.core.stripPrefix.<anonymous>' call
          var it = charSequenceGet(_this__u8e3s4, index);
          if (!(digitToIntOrNull(it) == null)) {
            tmp$ret$1 = index;
            break $l$block;
          }
        }
         while (inductionVariable <= last);
      tmp$ret$1 = -1;
    }
    var startIndex = tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    return _this__u8e3s4.substring(startIndex);
  }
  function calculateNextVersion(_this__u8e3s4, implicitPatch, versionRegex, releaseBranch) {
    var tmp0_elvis_lhs = lastVersionAndTag(_this__u8e3s4);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return '0.0.0';
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var tmp1_container = tmp;
    var previousVersionNumber = tmp1_container.a6();
    var lastTagDescription = tmp1_container.b6();
    var incrementComponent = findAppropriateIncrement(_this__u8e3s4.it_1, lastTagDescription, implicitPatch, versionRegex);
    var tmp3_elvis_lhs = incrementComponent == null ? null : incrementComponent.mt(asSemverComponents(previousVersionNumber));
    var currentVersionNumber = tmp3_elvis_lhs == null ? previousVersionNumber : tmp3_elvis_lhs;
    var tmp_0;
    if (canRelease(_this__u8e3s4.it_1.vs(), releaseBranch) ? !(currentVersionNumber === previousVersionNumber) : false) {
      tmp_0 = currentVersionNumber;
    } else {
      tmp_0 = currentVersionNumber + '-SNAPSHOT';
    }
    return tmp_0;
  }
  function ChangeType$Major() {
    ChangeType.call(this, 'Major', 0, 3);
    ChangeType_Major_instance = this;
  }
  protoOf(ChangeType$Major).mt = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    return '' + (major + 1 | 0) + '.0.0';
  };
  var ChangeType_Major_instance;
  function ChangeType$Minor() {
    ChangeType.call(this, 'Minor', 1, 2);
    ChangeType_Minor_instance = this;
  }
  protoOf(ChangeType$Minor).mt = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    return '' + major + '.' + (minor + 1 | 0) + '.0';
  };
  var ChangeType_Minor_instance;
  function ChangeType$Patch() {
    ChangeType.call(this, 'Patch', 2, 1);
    ChangeType_Patch_instance = this;
  }
  protoOf(ChangeType$Patch).mt = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.c1(2);
    return '' + major + '.' + minor + '.' + (patch + 1 | 0);
  };
  var ChangeType_Patch_instance;
  function ChangeType$None() {
    ChangeType.call(this, 'None', 3, 0);
    ChangeType_None_instance = this;
  }
  protoOf(ChangeType$None).mt = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.c1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.c1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.c1(2);
    return '' + major + '.' + minor + '.' + patch;
  };
  var ChangeType_None_instance;
  var ChangeType_entriesInitialized;
  function ChangeType_initEntries() {
    if (ChangeType_entriesInitialized)
      return Unit_instance;
    ChangeType_entriesInitialized = true;
    ChangeType_Major_instance = new ChangeType$Major();
    ChangeType_Minor_instance = new ChangeType$Minor();
    ChangeType_Patch_instance = new ChangeType$Patch();
    ChangeType_None_instance = new ChangeType$None();
  }
  function ChangeType(name, ordinal, priority) {
    Enum.call(this, name, ordinal);
    this.lt_1 = priority;
  }
  function findAppropriateIncrement(gitAdapter, previousTag, implicitPatch, minorRegex) {
    // Inline function 'kotlin.collections.fold' call
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.also' call
    var this_0 = gitAdapter.us('HEAD', '^' + previousTag);
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
    if (this_0.y())
      return null;
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.r();
    while (tmp0_iterator.s()) {
      var item = tmp0_iterator.u();
      // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
      var tmp0_elvis_lhs = changeType(item, minorRegex);
      var tmp$ret$1 = tmp0_elvis_lhs == null ? implicitPatch ? ChangeType_Patch_getInstance() : null : tmp0_elvis_lhs;
      destination.o(tmp$ret$1);
    }
    var accumulator = null;
    var tmp0_iterator_0 = destination.r();
    while (tmp0_iterator_0.s()) {
      var element = tmp0_iterator_0.u();
      accumulator = highestPriority(accumulator, element);
    }
    var tmp0_elvis_lhs_0 = accumulator;
    return tmp0_elvis_lhs_0 == null ? implicitPatch ? ChangeType_Patch_getInstance() : ChangeType_None_getInstance() : tmp0_elvis_lhs_0;
  }
  function canRelease(_this__u8e3s4, releaseBranch) {
    return ((_this__u8e3s4.xs_1 ? _this__u8e3s4.ys_1 === 0 : false) ? _this__u8e3s4.zs_1 === 0 : false) ? _this__u8e3s4.at_1 === releaseBranch : false;
  }
  function highestPriority(left, right) {
    return left == null ? right : right == null ? left : left.lt_1 > right.lt_1 ? left : right;
  }
  function changeType(_this__u8e3s4, versionRegex) {
    // Inline function 'kotlin.text.trim' call
    var this_0 = _this__u8e3s4.qs_1;
    var tmp$ret$0 = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
    return changeType_0(versionRegex, tmp$ret$0);
  }
  function changeType_0(_this__u8e3s4, message) {
    var tmp;
    var tmp0_safe_receiver = _this__u8e3s4.du_1;
    if ((tmp0_safe_receiver == null ? null : tmp0_safe_receiver.z7(message)) === true) {
      tmp = findMatchType(message, _this__u8e3s4.du_1);
    } else {
      if (_this__u8e3s4.cu_1.z7(message)) {
        tmp = ChangeType_Major_getInstance();
      } else {
        if (_this__u8e3s4.bu_1.z7(message)) {
          tmp = ChangeType_Minor_getInstance();
        } else {
          if (_this__u8e3s4.au_1.z7(message)) {
            tmp = ChangeType_Patch_getInstance();
          } else {
            if (_this__u8e3s4.zt_1.z7(message)) {
              tmp = ChangeType_None_getInstance();
            } else {
              tmp = null;
            }
          }
        }
      }
    }
    return tmp;
  }
  function findMatchType(message, regex) {
    var tmp0_safe_receiver = regex.d8(message);
    var groups = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.u8();
    return groupExists(groups, 'major') ? ChangeType_Major_getInstance() : groupExists(groups, 'minor') ? ChangeType_Minor_getInstance() : groupExists(groups, 'patch') ? ChangeType_Patch_getInstance() : groupExists(groups, 'none') ? ChangeType_None_getInstance() : null;
  }
  function groupExists(_this__u8e3s4, groupName) {
    var tmp$ret$4;
    $l$block: {
      // Inline function 'kotlin.getOrDefault' call
      // Inline function 'kotlin.runCatching' call
      var tmp;
      try {
        // Inline function 'kotlin.Companion.success' call
        // Inline function 'com.zegreatrob.tools.tagger.core.groupExists.<anonymous>' call
        var value = !((_this__u8e3s4 == null ? null : get(_this__u8e3s4, groupName)) == null);
        tmp = _Result___init__impl__xyqfz8(value);
      } catch ($p) {
        var tmp_0;
        if ($p instanceof Error) {
          var e = $p;
          // Inline function 'kotlin.Companion.failure' call
          tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
        } else {
          throw $p;
        }
        tmp = tmp_0;
      }
      var this_0 = tmp;
      if (_Result___get_isFailure__impl__jpiriv(this_0)) {
        tmp$ret$4 = false;
        break $l$block;
      }
      var tmp_1 = _Result___get_value__impl__bjfvqg(this_0);
      tmp$ret$4 = (tmp_1 == null ? true : !(tmp_1 == null)) ? tmp_1 : THROW_CCE();
    }
    return tmp$ret$4;
  }
  function ChangeType_Major_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Major_instance;
  }
  function ChangeType_Minor_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Minor_instance;
  }
  function ChangeType_Patch_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Patch_instance;
  }
  function ChangeType_None_getInstance() {
    ChangeType_initEntries();
    return ChangeType_None_instance;
  }
  function lastVersionAndTag(_this__u8e3s4) {
    var tmp0_elvis_lhs = _this__u8e3s4.it_1.ws(0);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return null;
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var description = tmp;
    var tmp_0;
    if (contains(description, '-')) {
      tmp_0 = substringBefore(description, '-');
    } else {
      tmp_0 = description;
    }
    var previousVersionNumber = tmp_0;
    // Inline function 'kotlin.text.ifEmpty' call
    var tmp_1;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(previousVersionNumber) === 0) {
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_1 = null;
    } else {
      tmp_1 = previousVersionNumber;
    }
    var tmp1_safe_receiver = tmp_1;
    var tmp_2;
    if (tmp1_safe_receiver == null) {
      tmp_2 = null;
    } else {
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_2 = to(tmp1_safe_receiver, description);
    }
    return tmp_2;
  }
  function TaggerCore(adapter) {
    this.it_1 = adapter;
  }
  protoOf(TaggerCore).toString = function () {
    return 'TaggerCore(adapter=' + this.it_1 + ')';
  };
  protoOf(TaggerCore).hashCode = function () {
    return hashCode(this.it_1);
  };
  protoOf(TaggerCore).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TaggerCore))
      return false;
    var tmp0_other_with_cast = other instanceof TaggerCore ? other : THROW_CCE();
    if (!equals(this.it_1, tmp0_other_with_cast.it_1))
      return false;
    return true;
  };
  function Defaults() {
    Defaults_instance = this;
    this.eu_1 = Defaults_getInstance().ft_1;
    this.fu_1 = Defaults_getInstance().et_1;
    this.gu_1 = Defaults_getInstance().dt_1;
    this.hu_1 = Defaults_getInstance().ct_1;
  }
  var Defaults_instance;
  function Defaults_getInstance_0() {
    if (Defaults_instance == null)
      new Defaults();
    return Defaults_instance;
  }
  function Companion() {
    this.iu_1 = "version regex must include groups named 'major', 'minor', 'patch', and 'none'.";
  }
  protoOf(Companion).ju = function (regexPattern) {
    return ((contains(regexPattern, '?<major>') ? contains(regexPattern, '?<minor>') : false) ? contains(regexPattern, '?<patch>') : false) ? contains(regexPattern, '?<none>') : false;
  };
  var Companion_instance_0;
  function Companion_getInstance() {
    return Companion_instance_0;
  }
  function VersionRegex(none, patch, minor, major, unified) {
    this.zt_1 = none;
    this.au_1 = patch;
    this.bu_1 = minor;
    this.cu_1 = major;
    this.du_1 = unified;
  }
  protoOf(VersionRegex).toString = function () {
    return 'VersionRegex(none=' + this.zt_1 + ', patch=' + this.au_1 + ', minor=' + this.bu_1 + ', major=' + this.cu_1 + ', unified=' + this.du_1 + ')';
  };
  protoOf(VersionRegex).hashCode = function () {
    var result = hashCode(this.zt_1);
    result = imul(result, 31) + hashCode(this.au_1) | 0;
    result = imul(result, 31) + hashCode(this.bu_1) | 0;
    result = imul(result, 31) + hashCode(this.cu_1) | 0;
    result = imul(result, 31) + (this.du_1 == null ? 0 : hashCode(this.du_1)) | 0;
    return result;
  };
  protoOf(VersionRegex).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionRegex))
      return false;
    var tmp0_other_with_cast = other instanceof VersionRegex ? other : THROW_CCE();
    if (!equals(this.zt_1, tmp0_other_with_cast.zt_1))
      return false;
    if (!equals(this.au_1, tmp0_other_with_cast.au_1))
      return false;
    if (!equals(this.bu_1, tmp0_other_with_cast.bu_1))
      return false;
    if (!equals(this.cu_1, tmp0_other_with_cast.cu_1))
      return false;
    if (!equals(this.du_1, tmp0_other_with_cast.du_1))
      return false;
    return true;
  };
  //region block: init
  Companion_instance_0 = new Companion();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = TaggerCore;
  _.$_$.b = VersionRegex;
  _.$_$.c = calculateNextVersion;
  _.$_$.d = Companion_instance_0;
  _.$_$.e = Defaults_getInstance_0;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./tools-digger-core.js')));

//# sourceMappingURL=tools-tagger-core.js.map
